DROP TABLE IF EXISTS games;
CREATE TABLE games
(
  game_id INTEGER NOT NULL,
  author TEXT COLLATE NOCASE NOT NULL,
  title TEXT COLLATE NOCASE NOT NULL,
  category TEXT COLLATE NOCASE NOT NULL,
  rating REAL DEFAULT 0 NOT NULL,
  flags INTEGER DEFAULT 0,
  
  bgcolor TEXT DEFAULT NULL,
  width INTEGER NOT NULL,
  height INTEGER NOT NULL,

  files TEXT NOT NULL,
  icon_url TEXT NOT NULL,
  featured_image TEXT DEFAULT NULL,
  latest_version INTEGER NOT NULL,
  published_at INTEGER NOT NULL,

  description TEXT DEFAULT NULL,
  instructions TEXT DEFAULT NULL,
  news TEXT DEFAULT NULL,

  key_mappings TEXT DEFAULT NULL
);
CREATE UNIQUE INDEX idx_games_on_game_id ON games(game_id);

DROP TABLE IF EXISTS statistics;
CREATE TABLE statistics
(
  statistic_id INTEGER UNIQUE NOT NULL,
  game_id INTEGER NOT NULL REFERENCES games(game_id) ON DELETE CASCADE,
  name TEXT NOT NULL,
  stat_type TEXT COLLATE NOCASE DEFAULT "max" NOT NULL,
  display_in_table INTEGER NOT NULL,
  display_name TEXT DEFAULT NULL
);
CREATE INDEX idx_statistics_on_game_id ON statistics(game_id);

ALTER TABLE incoming_challenges RENAME TO challenges;
ALTER TABLE challenges ADD COLUMN game_id DEFAULT NULL;