ALTER TABLE statistic_records ADD COLUMN best_value INTEGER;
ALTER TABLE statistic_records ADD COLUMN game_id INTEGER;
UPDATE statistic_records SET best_value = (statistic_records.accumulated_value + statistic_records.current_value);
UPDATE statistic_records SET game_id = (SELECT game_id FROM statistics WHERE statistics.statistic_id=statistic_records.statistic_id);
DELETE FROM statistic_records WHERE game_id IS NULL;

CREATE TEMPORARY TABLE records_backup(statistic_id, game_id, user_id, current_value, best_value);
INSERT INTO records_backup SELECT statistic_id, game_id, user_id, current_value, best_value FROM statistic_records;
UPDATE records_backup SET current_value = NULL;

DROP TABLE statistic_records;
CREATE TABLE statistic_records
(
  statistic_id INTEGER NOT NULL REFERENCES statistics(statistic_id) ON DELETE CASCADE,
  game_id INTEGER NOT NULL REFERENCES games(game_id) ON DELETE CASCADE,
  user_id INTEGER NOT NULL,
  current_value INTEGER DEFAULT NULL,
  best_value INTEGER DEFAULT NULL
);
CREATE UNIQUE INDEX idx_sr_on_user_id_and_statistic_id ON statistic_records(user_id, statistic_id);

INSERT INTO statistic_records SELECT statistic_id, game_id, user_id, current_value, best_value FROM records_backup;